Public Class BeschriftungsRechteckListe
    Inherits List(Of BeschriftungsRechteck)
    Private m_SelectedRE As BeschriftungsRechteck
    Public Event Changed()
    Public Event SelectedRechteckChanged(ByVal Sender As Object)
    'Property SelectedRE() As BeschriftungsRechteck
    '    Get
    '        Return m_SelectedRE
    '    End Get
    '    Set(ByVal value As BeschriftungsRechteck)
    '        m_SelectedRE = value
    '        RaiseEvent Changed()
    '    End Set
    'End Property
    ReadOnly Property SelectedRE() As BeschriftungsRechteck
        Get
            Return m_SelectedRE
        End Get
    End Property


    Shadows Sub Add(ByVal RE As BeschriftungsRechteck)
        MyBase.Add(RE)
        AddHandler RE.Changed, AddressOf OnRechteckChanged
        m_SelectedRE = RE
        RaiseEvent Changed()
    End Sub
    Shadows Sub Remove(ByVal RE As BeschriftungsRechteck)
        MyBase.Remove(RE)
        RemoveHandler RE.Changed, AddressOf OnRechteckChanged
        If m_SelectedRE Is RE Then
            m_SelectedRE = Nothing
        End If
        RaiseEvent Changed()
    End Sub
    Shadows Sub Insert(ByVal Idx As Integer, ByVal Value As BeschriftungsRechteck)
        MyBase.Insert(Idx, Value)
        AddHandler Value.Changed, AddressOf OnRechteckChanged
        RaiseEvent Changed()
    End Sub
    Public Sub SetSelected(ByVal SelRE As BeschriftungsRechteck, ByVal Sender As Object)
        m_SelectedRE = SelRE
        RaiseEvent Changed()
        RaiseEvent SelectedRechteckChanged(Sender)
    End Sub
    Private Sub OnRechteckChanged()
        RaiseEvent Changed()
    End Sub
End Class
