Public Class BildDatumsComparer
    Implements IComparer(Of Bild)

    Public Function Compare(ByVal x As Bild, ByVal y As Bild) As Integer Implements System.Collections.Generic.IComparer(Of Bild).Compare
        'Sortierreihenfolge: Datum->Autor->QuellNr
        Dim Erg As Integer = x.Datumsangabe.ToDatum.CompareTo(y.Datumsangabe.ToDatum)
        If Erg <> 0 Then Return Erg

        Erg = x.Autor.Name.CompareTo(y.Autor.Name)
        If Erg <> 0 Then Return Erg

        If IsNumeric(x.QuellIndex) And IsNumeric(y.QuellIndex) Then
            Try
                Dim Ix As Integer = CInt(x.QuellIndex)
                Dim Iy As Integer = CInt(y.QuellIndex)
                Return Ix.CompareTo(Iy)
            Catch ex As Exception

            End Try
        End If

        Return x.QuellIndex.CompareTo(y.QuellIndex)
    End Function
End Class
