Public Class BildeigenschaftsEditor
    'Private m_Bild As Bild
    Private m_Initialisation As Boolean = False
    Private m_DS As Datensammlung
    'Private m_Datumsangaben As DatumsangabeListe
    Public Sub Init(ByVal DS As Datensammlung)
        m_DS = DS
        'm_Datumsangaben = Datumsangaben
        m_Initialisation = True
        Me.ComboBoxAutor.Items.Clear()
        Me.ComboBoxAutor.Items.AddRange(m_DS.Autoren.ToArray)
        Me.ComboBoxAutor.SelectedIndex = 0
        Me.DatumsangabeEditor1.Init(m_DS.Datumsangaben)
        m_Initialisation = False
    End Sub

    Private m_Bilder As List(Of Bild)
    WriteOnly Property Bilder() As List(Of Bild)
        Set(ByVal value As List(Of Bild))
            m_Bilder = value
            Werte_Lesen()
        End Set
    End Property

    'WriteOnly Property Bild() As Bild
    '    Set(ByVal value As Bild)
    '        If m_Bild IsNot value Then
    '            m_Bild = value
    '            Werte_Lesen()
    '        End If
    '    End Set
    'End Property
    Private Sub Werte_Lesen()
        m_Initialisation = True
        If m_Bilder.Count = 0 Then
            'If m_Bild Is Nothing Then
            Me.TextBoxBeschreibung.Text = ""
            Me.TextBoxBeschreibung.Enabled = False
            Me.TextBoxQuellenIndex.Text = ""
            Me.TextBoxQuellenIndex.Enabled = False
            Me.ComboBoxAutor.SelectedIndex = 0
            Me.ComboBoxAutor.Enabled = False
            Me.TextBoxQuellenIndex.Enabled = False
            Me.DatumsangabeEditor1.Bilder = m_Bilder
            Me.ButtonAutorenBearbeiten.Enabled = False
            'Me.DatumsangabeEditor1.SetValues(m_Datumsangaben, Nothing)
            Me.LabelSize.Text = ""
            Me.BeschriftungsRechteckEditor1.Enabled = False
            Me.BeschriftungsRechteckEditor1.Init(Nothing)
        ElseIf m_Bilder.Count = 1 Then
            Me.TextBoxBeschreibung.Text = m_Bilder(0).Beschreibung
            Me.TextBoxBeschreibung.Enabled = True
            Me.TextBoxQuellenIndex.Text = m_Bilder(0).QuellIndex
            Me.TextBoxQuellenIndex.Enabled = True
            Me.ComboBoxAutor.SelectedItem = m_Bilder(0).Autor
            Me.ComboBoxAutor.Enabled = True
            Me.LabelSize.Text = "B" & m_Bilder(0).Size.Width.ToString & ", H" & m_Bilder(0).Size.Height.ToString
            Me.DatumsangabeEditor1.Bilder = m_Bilder
            Me.ButtonAutorenBearbeiten.Enabled = True
            'Me.DatumsangabeEditor1.SetValues(m_Datumsangaben, m_Bild)
            Me.BeschriftungsRechteckEditor1.Enabled = True
            Me.BeschriftungsRechteckEditor1.Init(m_Bilder(0).Beschriftungen)
        Else
            ' m_Bilder.Count > 1 
            Dim BeschreibungGleich As Boolean = True
            For I As Integer = 1 To m_Bilder.Count - 1
                If m_Bilder(I).Beschreibung <> m_Bilder(0).Beschreibung Then
                    BeschreibungGleich = False
                    Exit For
                End If
            Next
            If BeschreibungGleich Then
                Me.TextBoxBeschreibung.Text = m_Bilder(0).Beschreibung
            Else
                Me.TextBoxBeschreibung.Text = ""
            End If
            Me.TextBoxBeschreibung.Enabled = True

            Dim QuellIndexGleich As Boolean = True
            For I As Integer = 1 To m_Bilder.Count - 1
                If m_Bilder(I).QuellIndex <> m_Bilder(0).QuellIndex Then
                    QuellIndexGleich = False
                    Exit For
                End If
            Next
            If QuellIndexGleich Then
                Me.TextBoxQuellenIndex.Text = m_Bilder(0).QuellIndex
            Else
                Me.TextBoxQuellenIndex.Text = ""
            End If
            Me.TextBoxQuellenIndex.Enabled = True

            Dim AutorGleich As Boolean = True
            For I As Integer = 1 To m_Bilder.Count - 1
                If m_Bilder(I).Autor IsNot m_Bilder(0).Autor Then
                    AutorGleich = False
                    Exit For
                End If
            Next
            If AutorGleich Then
                Me.ComboBoxAutor.SelectedItem = m_Bilder(0).Autor
            Else
                Me.ComboBoxAutor.SelectedIndex = -1
            End If
            Me.ComboBoxAutor.Enabled = True
            Dim SizeGleich As Boolean = True
            For I As Integer = 1 To m_Bilder.Count - 1
                If m_Bilder(I).Size <> m_Bilder(0).Size Then
                    SizeGleich = False
                    Exit For
                End If
            Next
            If SizeGleich Then
                Me.LabelSize.Text = "B" & m_Bilder(0).Size.Width.ToString & ", H" & m_Bilder(0).Size.Height.ToString
            Else
                Me.LabelSize.Text = ""
            End If


            Me.DatumsangabeEditor1.Bilder = m_Bilder
            Me.ButtonAutorenBearbeiten.Enabled = True
            Me.BeschriftungsRechteckEditor1.Enabled = False
            Me.BeschriftungsRechteckEditor1.Init(Nothing)
        End If
        m_Initialisation = False
    End Sub

    Private Sub TextBoxBeschreibung_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxBeschreibung.TextChanged
        If m_Initialisation Then Exit Sub
        For Each Bld As Bild In m_Bilder
            Bld.Beschreibung = TextBoxBeschreibung.Text
        Next

    End Sub

    Private Sub ComboBoxAutor_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxAutor.SelectedIndexChanged
        If m_Initialisation Then Exit Sub
        For Each Bld As Bild In m_Bilder
            Bld.Autor = ComboBoxAutor.SelectedItem
        Next
    End Sub

    Private Sub TextBoxQuellenIndex_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxQuellenIndex.TextChanged
        If m_Initialisation Then Exit Sub
        For Each Bld As Bild In m_Bilder
            Bld.QuellIndex = TextBoxQuellenIndex.Text
        Next

    End Sub

    Private Sub BildeigenschaftsEditor_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Me.ComboBoxAutor.SelectionLength = 0
    End Sub

    Private Sub ButtonAutorenBearbeiten_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAutorenBearbeiten.Click
        Dim frm As New frm_AutorenBearbeiten(m_DS.Autoren)
        If frm.ShowDialog = DialogResult.OK Then
            Dim DeletedAutors As New List(Of Autor)
            For Each Aut As EditAutor In frm.DeletedAutors
                For Each Bld As Bild In m_DS.Bilder
                    If Bld.Autor Is Aut.Autor Then
                        DeletedAutors.Add(Aut.Autor)
                        Exit For
                    End If
                Next
            Next


            If DeletedAutors.Count > 0 Then
                Dim AutorenNamen As New List(Of String)
                For Each Aut As Autor In DeletedAutors
                    AutorenNamen.Add(Aut.Name)
                Next
                Dim AutorText As String = Join(AutorenNamen.ToArray, ", ")
                If DeletedAutors.Count = 1 Then
                    If MessageBox.Show("Der Autor " & AutorText & " wird fr wenigstens ein Bild verwendet." & vbCrLf & _
                    "Soll fr die betreffenden Bilder wirklich ""unbekannt"" fr den Autor festgelegt werden?", "PhotoCollector", MessageBoxButtons.OKCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) = DialogResult.Cancel Then Exit Sub
                Else
                    If MessageBox.Show("Die Autoren " & AutorText & " werden jeweils fr wenigstens ein Bild verwendet." & vbCrLf & _
                    "Soll fr die betreffenden Bilder wirklich ""unbekannt"" fr den Autor festgelegt werden?", "PhotoCollector", MessageBoxButtons.OKCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) = DialogResult.Cancel Then Exit Sub
                End If
            End If


            For Each Aut As EditAutor In frm.DeletedAutors
                Dim AktAut As Autor = Aut.Autor

                If Me.ComboBoxAutor.SelectedItem Is AktAut Then
                    ComboBoxAutor.SelectedItem = StandardAutor
                End If
                
                For Each Bld As Bild In m_DS.Bilder
                    If Bld.Autor Is AktAut Then
                        Bld.Autor = StandardAutor
                    End If
                Next

                ComboBoxAutor.Items.Remove(AktAut)
                m_DS.Autoren.Remove(AktAut)
            Next


            Dim SelItem As Autor = ComboBoxAutor.SelectedItem

            For Each Aut As EditAutor In frm.ListBoxAutoren.Items
                Dim Idx As Integer = frm.ListBoxAutoren.Items.IndexOf(Aut)
                If Aut.Autor Is Nothing Then
                    Dim NewAutor As New Autor(Aut.NewName)
                    NewAutor.Link = Aut.NewLink

                    m_DS.Autoren.Insert(Idx, NewAutor)
                    ComboBoxAutor.Items.Insert(Idx, NewAutor)
                Else
                    Dim EAut As Autor = Aut.Autor
                    EAut.Name = Aut.NewName
                    EAut.Link = Aut.NewLink

                    m_DS.Autoren.Remove(EAut)
                    ComboBoxAutor.Items.Remove(EAut)

                    m_DS.Autoren.Insert(Idx, EAut)
                    ComboBoxAutor.Items.Insert(Idx, EAut)
                End If

            Next
            ComboBoxAutor.SelectedItem = SelItem

        End If
    End Sub
End Class
