Public Class DatumEditorJahreszeit
    Implements IDatumEditor

    Public Sub New(ByVal DA As DatumsAngabeJahreszeit)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        For I As Integer = 1 To 4
            Me.ComboBoxJahreszeit.Items.Add(CType(I, Jahreszeiten))
        Next
        SetValue(DA)

    End Sub

    Public Function HasValidValue() As Boolean Implements IDatumEditor.HasValidValue
        Try
            Dim Dat As New Date(CInt(Me.TextBoxJahr.Text), 1, 1)
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    Public Function CreateValue() As IDatumsAngabe Implements IDatumEditor.CreateValue
        Return New DatumsAngabeJahreszeit(ComboBoxJahreszeit.SelectedItem, CInt(Me.TextBoxJahr.Text))
    End Function

    Public Sub SetValue(ByVal Wert As IDatumsAngabe) Implements IDatumEditor.SetValue
        Dim Dat As DatumsAngabeJahreszeit = Wert
        Me.TextBoxJahr.Text = Dat.ToDatum.Year.ToString
        ComboBoxJahreszeit.SelectedItem = Dat.Jahreszeit
    End Sub
End Class
