Imports System.Drawing.Drawing2D
Public Class DescriptionLabel
    Private m_BMP As Bitmap = Nothing
    Protected Overrides Sub OnPaint(ByVal pe As System.Windows.Forms.PaintEventArgs)
        'MyBase.OnPaint(pe)
        Dim Rect As New Rectangle(0, 0, Me.Width, Me.Height)
        'Benutzerdefinierten Zeichnungscode hier einfügen
        If m_BMP Is Nothing Then
            m_BMP = New Bitmap(Me.Width, Me.Height)
            Dim g As Graphics = Graphics.FromImage(m_BMP)
            Dim BackBrush As New LinearGradientBrush(Rect, Me.ForeColor, Me.BackColor, 115.0F)
            g.FillRectangle(BackBrush, Rect)
            Using ForeBrush As New SolidBrush(Me.ForeColor)
                g.DrawString(Me.Text, Me.Font, ForeBrush, 2, 2)
            End Using

        End If
        pe.Graphics.DrawImage(m_BMP, Rect)
    End Sub
    Protected Overrides Sub OnResize(ByVal e As System.EventArgs)
        MyBase.OnResize(e)
        m_BMP = Nothing
        Invalidate()
    End Sub

    Public Sub New()

        ' Dieser Aufruf ist für den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.SetStyle(ControlStyles.DoubleBuffer _
             Or ControlStyles.UserPaint _
             Or ControlStyles.AllPaintingInWmPaint, _
             True)

    End Sub
End Class
