Public Class AsynchronBildLader
    'Diese Klasse ermglicht, ein Bild mit einem Thread im Hintergrund zu laden
    'Damit wird nicht die ganze Anwendung blockiert, whrend ein greres
    'Bild geladen wird
    Private m_Image As Image
    Private m_Pfad As String = ""
    Private m_TempPfad As String = ""
    Private m_LadeThread As Threading.Thread
    Public Event Bild_Geaendert()
    ReadOnly Property Image() As Image
        Get
            Return m_Image
        End Get
    End Property
    ReadOnly Property Pfad() As String
        Get
            Return m_Pfad
        End Get
    End Property

    Public Sub Bild_Laden(ByVal Pfad As String)
        If m_LadeThread IsNot Nothing Then
            m_LadeThread.Abort()
        End If
        'm_LadeThread.Join()

        If Pfad = "" Then
            m_Image = Nothing
            m_Pfad = ""
            RaiseEvent Bild_Geaendert()
            Exit Sub
        End If

        m_TempPfad = Pfad
        m_LadeThread = New Threading.Thread(AddressOf Laden)
        m_LadeThread.Start()
    End Sub
    Private Sub Laden()
        Dim Str As New IO.FileStream(m_TempPfad, IO.FileMode.Open, IO.FileAccess.Read, IO.FileShare.Read, 1024, IO.FileOptions.Asynchronous)
        m_Image = Drawing.Image.FromStream(Str)
        Str.Close()
        m_Pfad = m_TempPfad
        RaiseEvent Bild_Geaendert()
    End Sub

End Class
