Public Class frm_AutorenBearbeiten

    Private m_DeletedAutors As New List(Of EditAutor)
    Private Initialisierung As Boolean = False
    ReadOnly Property DeletedAutors() As List(Of EditAutor)
        Get
            Return m_DeletedAutors
        End Get
    End Property

    Private Sub frm_AutorenBearbeiten_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.CommandPanel1.ButtonMoveLeft.Visible = False
        Me.CommandPanel1.ButtonMoveRight.Visible = False
        Me.CommandPanel1.ButtonEdit.Visible = False
        Me.CommandPanel1.ButtonMoveDown.Left = 2
        Me.CommandPanel1.ButtonMoveUp.Left = 28
    End Sub

    Public Sub New(ByVal Autoren As List(Of Autor))

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        For Each Aut As Autor In Autoren
            Me.ListBoxAutoren.Items.Add(New EditAutor(Aut))
        Next
        ListBoxAutoren.SelectedIndex = 0
    End Sub

    Private Sub ListBoxAutoren_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBoxAutoren.SelectedIndexChanged
        Dim Aut As EditAutor = Nothing
        If ListBoxAutoren.SelectedIndex > -1 Then
            Aut = ListBoxAutoren.SelectedItem
        End If
        Initialisierung = True
        If ListBoxAutoren.SelectedIndex = -1 OrElse Aut.Autor Is StandardAutor Then
            Me.TextBoxName.Text = ""
            Me.TextBoxLink.Text = ""
            Me.TextBoxName.Enabled = False
            Me.TextBoxLink.Enabled = False
            Me.CommandPanel1.ButtonDelete.Enabled = False
        Else
            Me.TextBoxName.Text = Aut.NewName
            Me.TextBoxLink.Text = Aut.NewLink
            Me.TextBoxName.Enabled = True
            Me.TextBoxLink.Enabled = True
            Me.CommandPanel1.ButtonDelete.Enabled = True
        End If

        If ListBoxAutoren.SelectedIndex = -1 Then
            Me.CommandPanel1.ButtonMoveDown.Enabled = False
            Me.CommandPanel1.ButtonMoveUp.Enabled = False
        Else
            If ListBoxAutoren.SelectedIndex = 0 Then
                Me.CommandPanel1.ButtonMoveUp.Enabled = False
            Else
                Me.CommandPanel1.ButtonMoveUp.Enabled = True
            End If
            If ListBoxAutoren.SelectedIndex = ListBoxAutoren.Items.Count - 1 Then
                Me.CommandPanel1.ButtonMoveDown.Enabled = False
            Else
                Me.CommandPanel1.ButtonMoveDown.Enabled = True
            End If
        End If


        Initialisierung = False
    End Sub

    Private Sub CommandPanel1_AddNew() Handles CommandPanel1.AddNew
        Dim NeuAut As New EditAutor
        ListBoxAutoren.Items.Add(NeuAut)
        ListBoxAutoren.SelectedItem = NeuAut
    End Sub

    Private Sub CommandPanel1_Delete() Handles CommandPanel1.Delete
        Dim Idx As Integer = ListBoxAutoren.SelectedIndex
        Dim Aut As EditAutor = ListBoxAutoren.SelectedItem
        If Aut.Autor IsNot Nothing Then
            m_DeletedAutors.Add(Aut)
        End If
        ListBoxAutoren.Items.Remove(Aut)
        Idx -= 1
        If Idx > -1 Then
            ListBoxAutoren.SelectedIndex = Idx
        Else
            ListBoxAutoren.SelectedIndex = 0
        End If
    End Sub

    Private Sub TextBoxName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxName.TextChanged
        If Initialisierung Then Exit Sub
        Dim Aut As EditAutor = ListBoxAutoren.SelectedItem
        If TextBoxName.Text <> "unbekannt" Then
            Aut.NewName = TextBoxName.Text
        End If
    
    End Sub

    Private Sub TextBoxLink_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxLink.TextChanged
        If Initialisierung Then Exit Sub
        Dim Aut As EditAutor = ListBoxAutoren.SelectedItem
        Aut.NewLink = TextBoxLink.Text
    End Sub

    Private Sub CommandPanel1_MoveDown() Handles CommandPanel1.MoveDown
        Dim Aut As EditAutor = ListBoxAutoren.SelectedItem
        Dim Idx As Integer = ListBoxAutoren.SelectedIndex

        ListBoxAutoren.Items.Remove(Aut)
        ListBoxAutoren.Items.Insert(Idx + 1, Aut)
        ListBoxAutoren.SelectedItem = Aut
    End Sub

    Private Sub CommandPanel1_MoveUp() Handles CommandPanel1.MoveUp

        Dim Aut As EditAutor = ListBoxAutoren.SelectedItem
        Dim Idx As Integer = ListBoxAutoren.SelectedIndex

        ListBoxAutoren.Items.Remove(Aut)
        ListBoxAutoren.Items.Insert(Idx - 1, Aut)
        ListBoxAutoren.SelectedItem = Aut

    End Sub

    Private Sub TextBoxName_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBoxName.Validating
        If ListBoxAutoren.SelectedIndex = -1 Then Exit Sub
        Initialisierung = True
        Dim Aut As EditAutor = ListBoxAutoren.SelectedItem
        Dim Idx As Integer = ListBoxAutoren.SelectedIndex
        ListBoxAutoren.Items.Remove(Aut)
        ListBoxAutoren.Items.Insert(Idx, Aut)
        ListBoxAutoren.SelectedItem = Aut
        Initialisierung = False
    End Sub
End Class