Imports System.Xml
Public Class Autor
    Public Event Changed()
    Private m_Name As String = ""
    Private m_Link As String = ""
    Property Name() As String
        Get
            Return m_Name
        End Get
        Set(ByVal value As String)
            If m_Name <> value Then
                m_Name = value
                RaiseEvent Changed()
            End If
        End Set
    End Property
    Property Link() As String
        Get
            Return m_Link
        End Get
        Set(ByVal value As String)
            m_Link = value
        End Set
    End Property
    Public Sub New(ByVal Name As String)
        m_Name = Name
    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        m_Name = Nd.Attributes("Name").Value
        For Each Att As XmlAttribute In Nd.Attributes
            If Att.Name = "Link" Then
                m_Link = Nd.Attributes("Link").Value
                Exit For
            End If
        Next
    End Sub
    Public Sub Write_XML(ByVal writer As XmlTextWriter)
        writer.WriteAttributeString("Name", m_Name)
        writer.WriteAttributeString("Link", m_Link)
    End Sub

    Public Overrides Function ToString() As String
        Return m_Name
    End Function

End Class

Public Class EditAutor
    Private m_Aut As Autor
    Public NewName As String = ""
    Public NewLink As String = ""
    Public Sub New(ByVal Aut As Autor)
        m_Aut = Aut
        NewName = Aut.Name
        NewLink = Aut.Link
    End Sub
    Public Sub New()
        NewName = "Neuer Autor"
    End Sub
    ReadOnly Property Autor() As Autor
        Get
            Return m_Aut
        End Get
    End Property
    Public Overrides Function ToString() As String
        Return NewName
    End Function
End Class