Public Class BildAutorComparer
    Implements IComparer(Of Bild)

    Public Function Compare(ByVal x As Bild, ByVal y As Bild) As Integer Implements System.Collections.Generic.IComparer(Of Bild).Compare
        'Sortierreihenfolge: Autor->QuellNr->Datum
        Dim Erg As Integer = x.Autor.Name.CompareTo(y.Autor.Name)
        If Erg <> 0 Then Return Erg

        If IsNumeric(x.QuellIndex) And IsNumeric(y.QuellIndex) Then
            Try
                Dim Ix As Integer = CInt(x.QuellIndex)
                Dim Iy As Integer = CInt(y.QuellIndex)
                Erg = Ix.CompareTo(Iy)
            Catch ex As Exception
                Erg = x.QuellIndex.CompareTo(y.QuellIndex)
            End Try
        Else
            Erg = x.QuellIndex.CompareTo(y.QuellIndex)
        End If

        If Erg = 0 Then
            Erg = x.Datumsangabe.ToDatum.CompareTo(y.Datumsangabe.ToDatum)
        End If
        Return Erg
    End Function
End Class
