Public Class BildgruppenEigenschaftseditor
    Private m_BildGruppe As BildGruppe
    Private m_Initialisierung As Boolean = False
    WriteOnly Property BildGruppe() As BildGruppe
        Set(ByVal value As BildGruppe)
            m_BildGruppe = value
            Init()
        End Set
    End Property
    Private Sub Init()
        m_Initialisierung = True
        If m_BildGruppe Is Nothing Then
            Me.TextBoxUeberschrift.Text = ""
            Me.TextBoxUeberschrift.Enabled = False
            Me.TextBoxBeschreibung.Text = ""
            Me.TextBoxBeschreibung.Enabled = False
        Else
            Me.TextBoxUeberschrift.Text = m_BildGruppe.Word
            Me.TextBoxUeberschrift.Enabled = True
            Me.TextBoxBeschreibung.Text = m_BildGruppe.Description
            Me.TextBoxBeschreibung.Enabled = True
        End If
        m_Initialisierung = False
    End Sub

    Private Sub TextBoxBeschreibung_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxBeschreibung.TextChanged
        If m_Initialisierung Then Exit Sub
        m_BildGruppe.Description = TextBoxBeschreibung.Text
    End Sub
    Private Sub TextBoxUeberschrift_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxUeberschrift.TextChanged
        If m_Initialisierung Then Exit Sub
        m_BildGruppe.Word = TextBoxUeberschrift.Text
    End Sub
End Class
