Public Class DatumEditorExifZeit
    Implements IDatumEditor


    Public Sub New(ByVal DA As DatumsAngabeExifZeit)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        SetValue(DA)
    End Sub

    Public Function HasValidValue() As Boolean Implements IDatumEditor.HasValidValue
        Try
            Dim Dat As New Date(CInt(Me.TextBoxJahr.Text), CInt(Me.TextBoxMonat.Text), CInt(Me.TextBoxTag.Text), CInt(Me.TextBoxStunden.Text), CInt(Me.TextBoxMinuten.Text), CInt(Me.TextBoxSekunden.Text))
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    Public Function CreateValue() As IDatumsAngabe Implements IDatumEditor.CreateValue
        Return New DatumsAngabeExifZeit(New Date(CInt(Me.TextBoxJahr.Text), CInt(Me.TextBoxMonat.Text), CInt(Me.TextBoxTag.Text), CInt(Me.TextBoxStunden.Text), CInt(Me.TextBoxMinuten.Text), CInt(Me.TextBoxSekunden.Text)))
    End Function

    Public Sub SetValue(ByVal Wert As IDatumsAngabe) Implements IDatumEditor.SetValue
        Dim Dat As Date = Wert.ToDatum
        Me.TextBoxJahr.Text = Dat.Year.ToString
        Me.TextBoxMonat.Text = Dat.Month.ToString
        Me.TextBoxTag.Text = Dat.Day.ToString
        Me.TextBoxStunden.Text = Dat.Hour.ToString
        Me.TextBoxMinuten.Text = Dat.Minute.ToString
        Me.TextBoxSekunden.Text = Dat.Second.ToString
    End Sub
End Class
