Public Class DatumEditorMonat
    Implements IDatumEditor

    Public Sub New(ByVal DA As DatumsAngabeMonat)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        SetValue(DA)
    End Sub

    Public Function HasValidValue() As Boolean Implements IDatumEditor.HasValidValue
        Try
            Dim Dat As New Date(CInt(Me.TextBoxJahr.Text), CInt(Me.TextBoxMonat.Text), 1)
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    Public Function CreateValue() As IDatumsAngabe Implements IDatumEditor.CreateValue
        Return New DatumsAngabeMonat(CType(CInt(Me.TextBoxMonat.Text), Monate), CInt(Me.TextBoxJahr.Text))
    End Function

    Public Sub SetValue(ByVal Wert As IDatumsAngabe) Implements IDatumEditor.SetValue
        Dim Dat As Date = Wert.ToDatum
        Me.TextBoxJahr.Text = Dat.Year.ToString
        Me.TextBoxMonat.Text = Dat.Month.ToString
    End Sub
End Class
