Public Class ZoomBeschriftungsPicBox
    Private WithEvents m_Beschriftungen As BeschriftungsRechteckListe


    Property Bild() As Bild
        Get
            Return Me.ZoomBeschriftungsControl1.Bild
        End Get
        Set(ByVal value As Bild)
            If value Is Nothing Then
                Me.ZoomBeschriftungsControl1.Bild = Nothing
                m_Beschriftungen = Nothing
                EnableButtons(False)
            Else
                Me.ZoomBeschriftungsControl1.Bild = value
                m_Beschriftungen = value.Beschriftungen
                EnableButtons(True)
            End If
        End Set
    End Property


    Private Sub EnableButtons(ByVal Value As Boolean)
        Me.ToolStripButtonMove.Enabled = Value
        Me.ToolStripButtonZoomOut.Enabled = Value
        Me.ToolStripButtonZoomIn.Enabled = Value
        Me.ToolStripButtonZoomFit.Enabled = Value
        Me.ToolStripButtonZoomPixels.Enabled = Value
        Me.ToolStripButtonProcessColors.Enabled = Value
        Me.ToolStripComboBoxZoom.Enabled = Value
        Me.ToolStripButtonBeschriftung.Enabled = Value
        Me.ToolStripButtonSelect.Enabled = Value


    End Sub


    Private Sub ZoomBeschriftungsControl1_ZoomChanged() Handles ZoomBeschriftungsControl1.ZoomChanged
        ToolStripComboBoxZoom.Text = ZoomBeschriftungsControl1.Zoom.ToString & "%"
    End Sub



    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.ToolStripComboBoxZoom.Items.Add("25%")
        Me.ToolStripComboBoxZoom.Items.Add("50%")
        Me.ToolStripComboBoxZoom.Items.Add("75%")
        Me.ToolStripComboBoxZoom.Items.Add("100%")
        Me.ToolStripComboBoxZoom.Items.Add("150%")
        Me.ToolStripComboBoxZoom.Items.Add("200%")
        Me.ToolStripComboBoxZoom.Items.Add("300%")
        Me.ToolStripComboBoxZoom.Items.Add("400%")
    End Sub


    Private Sub ToolStripComboBoxZoom_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripComboBoxZoom.SelectedIndexChanged
        Dim ZoomWert As Single
        Select Case ToolStripComboBoxZoom.SelectedIndex
            Case 0 : ZoomWert = 25.0F
            Case 1 : ZoomWert = 50.0F
            Case 2 : ZoomWert = 75.0F
            Case 3 : ZoomWert = 100.0F
            Case 4 : ZoomWert = 150.0F
            Case 5 : ZoomWert = 200.0F
            Case 6 : ZoomWert = 300.0F
            Case 7 : ZoomWert = 400.0F

        End Select


        Try
            ZoomBeschriftungsControl1.Zoom = ZoomWert
        Catch ex As Exception

        End Try

    End Sub

    Private Sub ToolStripButtonMove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonMove.Click
        Me.ZoomBeschriftungsControl1.Mode = PictureControlModes.Hand
        Me.ToolStripButtonMove.Checked = True
        Me.ToolStripButtonZoomIn.Checked = False
        Me.ToolStripButtonZoomOut.Checked = False
        Me.ToolStripButtonBeschriftung.Checked = False
        Me.ToolStripButtonSelect.Checked = False
    End Sub
    Private Sub ToolStripButtonZoomIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonZoomIn.Click
        ToolStripButtonZoomIn_Aktivieren()
    End Sub
    Private Sub ToolStripButtonZoomIn_Aktivieren()
        Me.ZoomBeschriftungsControl1.Mode = PictureControlModes.ZoomIn
        Me.ToolStripButtonMove.Checked = False
        Me.ToolStripButtonZoomIn.Checked = True
        Me.ToolStripButtonZoomOut.Checked = False
        Me.ToolStripButtonBeschriftung.Checked = False
        Me.ToolStripButtonSelect.Checked = False
    End Sub


    Private Sub ToolStripButtonZoomOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonZoomOut.Click
        Me.ZoomBeschriftungsControl1.Mode = PictureControlModes.ZoomOut
        Me.ToolStripButtonMove.Checked = False
        Me.ToolStripButtonZoomIn.Checked = False
        Me.ToolStripButtonZoomOut.Checked = True
        Me.ToolStripButtonBeschriftung.Checked = False
        Me.ToolStripButtonSelect.Checked = False
    End Sub

    Private Sub ToolStripButtonZoomFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonZoomFit.Click
        Me.ZoomBeschriftungsControl1.FitToControl()
    End Sub

    Private Sub ToolStripButtonZoomPixels_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonZoomPixels.Click
        Me.ZoomBeschriftungsControl1.ZoomPixels()
    End Sub

    Private Sub ToolStripButtonProcessColors_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonProcessColors.Click
        Me.ZoomBeschriftungsControl1.EditColors()
    End Sub


    Private Sub ToolStripButtonInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Process.Start(Application.StartupPath & "\info.html")
    End Sub

    Private Sub ToolStripButtonBeschriftung_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonBeschriftung.Click
        Me.ZoomBeschriftungsControl1.Mode = PictureControlModes.DrawRectangle
        Me.ToolStripButtonMove.Checked = False
        Me.ToolStripButtonZoomIn.Checked = False
        Me.ToolStripButtonZoomOut.Checked = False
        Me.ToolStripButtonBeschriftung.Checked = True
        Me.ToolStripButtonSelect.Checked = False
    End Sub

    'Private Sub m_Beschriftungen_Changed() Handles m_Beschriftungen.Changed
    '    If m_Beschriftungen.Count = 0 Then
    '        If Me.ZoomBeschriftungsControl1.Mode = PictureControlModes.DrawRectangle Then
    '            Me.ZoomBeschriftungsControl1.Mode = PictureControlModes.Hand
    '            Me.ToolStripButtonMove.Checked = True
    '            Me.ToolStripButtonZoomIn.Checked = False
    '            Me.ToolStripButtonZoomOut.Checked = False
    '            Me.ToolStripButtonBeschriftung.Checked = False
    '        End If
    '        Me.ToolStripButtonBeschriftung.Enabled = False
    '    Else
    '        Me.ToolStripButtonBeschriftung.Enabled = True
    '    End If

    'End Sub

    Private Sub ToolStripButtonSelect_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripButtonSelect.Click
        Me.ZoomBeschriftungsControl1.Mode = PictureControlModes.SelectMode
        Me.ToolStripButtonMove.Checked = False
        Me.ToolStripButtonZoomIn.Checked = False
        Me.ToolStripButtonZoomOut.Checked = False
        Me.ToolStripButtonBeschriftung.Checked = False
        Me.ToolStripButtonSelect.Checked = True
    End Sub
End Class
