'stellt eine Einfgemarke im ZoomListView dar
Public Class ZoomListViewInsertionMark
    Private m_Zeile As Integer = 0
    Private m_Spalte As Integer = 0
    Private m_ZielIndex As Integer = 0
    Private m_Location As PointF
    Private m_ZeilenHoehe As Single = 0.0F
    Public Sub New(ByVal Zeile As Integer, ByVal Spalte As Integer, ByVal ZielIndex As Integer, ByVal Location As PointF, ByVal ZeilenHoehe As Single)
        m_Zeile = Zeile
        m_Spalte = Spalte
        m_ZielIndex = ZielIndex
        m_Location = Location
        m_ZeilenHoehe = ZeilenHoehe
    End Sub
    Property Zeile() As Integer
        Get
            Return m_Zeile
        End Get
        Set(ByVal value As Integer)
            m_Zeile = value
        End Set
    End Property
    Property Spalte() As Integer
        Get
            Return m_Spalte
        End Get
        Set(ByVal value As Integer)
            m_Spalte = value
        End Set
    End Property
    ReadOnly Property ZielIndex() As Integer
        Get
            Return m_ZielIndex
        End Get
    End Property

    Public Sub Paint(ByVal g As Graphics, ByVal TopDistance As Integer)
        Dim BaseColor As Color = Color.Green
        Dim LightColor As Color = ControlPaint.LightLight(BaseColor)
        Dim DarkColor As Color = ControlPaint.DarkDark(BaseColor)
        Dim BasePen As New Pen(BaseColor, 2)
        Dim LightPen As New Pen(LightColor, 2)
        Dim DarkPen As New Pen(DarkColor, 2)

        Dim Pt1 As New PointF(m_Location.X, m_Location.Y - TopDistance)
        Dim Pt2 As New PointF(m_Location.X, m_Location.Y - TopDistance + m_ZeilenHoehe)

        g.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias

        Pt1.X -= 0.5F
        Pt1.Y -= 0.5F
        Pt2.X -= 0.5F
        Pt2.Y -= 0.5F
        g.DrawLine(LightPen, Pt1, Pt2)

        Pt1.X += 0.5F
        Pt1.Y += 0.5F
        Pt2.X += 0.5F
        Pt2.Y += 0.5F
        'g.DrawLine(BasePen, Pt1, Pt2)

        Pt1.X += 0.5F
        Pt1.Y += 0.5F
        Pt2.X += 0.5F
        Pt2.Y += 0.5F
        g.DrawLine(DarkPen, Pt1, Pt2)


        Pt1.X -= 0.5F
        Pt1.Y -= 0.5F
        Pt2.X -= 0.5F
        Pt2.Y -= 0.5F
        g.DrawLine(BasePen, Pt1, Pt2)

        g.SmoothingMode = Drawing2D.SmoothingMode.Default


        BasePen.Dispose()
        LightPen.Dispose()
        DarkPen.Dispose()
    End Sub
End Class


