Module Module1
    Public BasisPfad As String = ""
    Public StandardAutor As Autor
    Public UnbekanntDatumsAngabe As DatumsAngabeUnbekannt
    Public BildOrdnerPfad As String = ""
    Public ThumbOrdnerPfad As String = ""

    Public MainBildListe As List(Of Bild)
    Public Datumsliste As DatumsangabeListe

    Public Function GetPictureRectangle(ByVal DestinationRect As Rectangle, ByVal PicSize As Size) As Rectangle
        'Liefert ein Rechteck, um ein Bild zentriert und in maximal mglicher Gre
        'am Platz eines gegebenen Rechtecks zu zeichnen

        Dim pw As Integer = PicSize.Width
        Dim ph As Integer = PicSize.Height
        Dim dw As Integer = DestinationRect.Width
        Dim dh As Integer = DestinationRect.Height

        Dim scaleFactor As Double
        If pw / ph > dw / dh Then
            scaleFactor = dw / pw
        Else
            scaleFactor = dh / ph
        End If

        Dim x As Integer = CInt((CSng(dw) - scaleFactor * CSng(pw)) / 2.0F) + DestinationRect.X
        Dim y As Integer = CInt((CSng(dh) - scaleFactor * CSng(ph)) / 2.0F) + DestinationRect.Y

        Return New Rectangle(x, y, scaleFactor * pw, scaleFactor * ph)
    End Function

#Region " Threading "
    'Der AllThumbCheckThread dient zum Erstellen nicht vorhandener Thumbnails 
    'nach dem Hinzufgen neuer Bilder
    'Da das seine Zeit braucht und dabei nicht die ganze anwendung blockiert werden soll,
    'wird das Erstellen neuer Thumbnails per Thread erledigt

    Public Sub Start_AllThumbCheckThread()
        Abort_AllThumbCheckThread()

        AllThumbCheckThread = New Threading.Thread(AddressOf RefreshAllThumbs)
        AllThumbCheckThread.IsBackground = True
        AllThumbCheckThread.Start()
    End Sub
    Private AllThumbCheckThread As Threading.Thread
    Private Sub RefreshAllThumbs()
        For Each Bld As Bild In MainBildListe
            Bld.CheckCreateThumb(Datumsliste)
        Next
    End Sub
    Public Sub Abort_AllThumbCheckThread()
        If AllThumbCheckThread IsNot Nothing Then
            AllThumbCheckThread.Abort()
        End If
    End Sub
    'Public Sub RunAndJoin_AllThumbCheckThread()
    '    Abort_AllThumbCheckThread()

    '    AllThumbCheckThread = New Threading.Thread(AddressOf RefreshAllThumbs)
    '    AllThumbCheckThread.IsBackground = False
    '    AllThumbCheckThread.Start()
    '    AllThumbCheckThread.Join()
    'End Sub
#End Region
End Module
